<?php
/**
 * @package   Yandex id
 * @author    Outcode https://outcode.ru/
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */
defined('_JEXEC') or die('Restricted access');

class YandexApi{
  
  private $oauth_url = 'https://oauth.yandex.ru';
  private $login_url = 'https://login.yandex.ru/info?format=json';
  private $token_url = 'https://yandex-id.outcode.ru/';
  
  public function __construct(){    
    //throw new Exception('...'); 
  }
  
  /**
   * Получения токена для работы с API
   *
  */
  public function getToken() { 
    
    if ($curl = curl_init()) {

      curl_setopt($curl, CURLOPT_URL, $this->token_url);
      curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
      curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
      curl_setopt($curl, CURLOPT_POST, true);    

      $out = curl_exec($curl);
      curl_close($curl);
      
      $result = json_decode($out);

      if(isset($result->access_token)){
        return $result;
      }
      
      return false;

    }else{
      throw new Exception('cURL - не установлен');
    }     
  }
  
 
  /**
   * Создание oAuth приложения
   *
  */
  public function createOauthApp($oauth_token, $data) { 

    if ($curl = curl_init()) {

      $scopes = $data['scopes'];
      unset($data['scopes']);

      $query = http_build_query($data);
      $query .= '&scopes='.$scopes;

      curl_setopt($curl, CURLOPT_URL, $this->oauth_url.'/api/1/client/create/external');
      curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
      curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
      curl_setopt($curl, CURLOPT_POST, true);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $query);
      curl_setopt($curl, CURLOPT_HTTPHEADER, array(
          //'Content-Type: application/x-www-form-urlencoded',
          'Authorization:'.'oAuth '.$oauth_token
      ));    

      $out = curl_exec($curl);
      curl_close($curl);

      $result = json_decode($out);

      if(isset($result->client_id) && isset($result->client_secret)){
        return $result;
      }
      
      return false;

    }else{
      throw new Exception('cURL - не установлен');
    }     
  }
  
  /**
   * Редактирование oAuth приложения
   *
  */
  public function editOauthApp($oauth_token, $data) { 

    if ($curl = curl_init()) {

      $scopes = $data['scopes'];
      unset($data['scopes']);

      $query = http_build_query($data);
      $query .= '&scopes='.$scopes;      

      curl_setopt($curl, CURLOPT_URL, $this->oauth_url.'/api/1/client/edit/external');
      curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
      curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
      curl_setopt($curl, CURLOPT_POST, true);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $query);
      curl_setopt($curl, CURLOPT_HTTPHEADER, array(
          'Authorization:'.'oAuth '.$oauth_token
      ));    

      $out = curl_exec($curl);
      curl_close($curl);

      $result = json_decode($out);

      if(isset($result->status) && $result->status == 'ok'){
        return true;
      }
      
      return false;

    }else{
      throw new Exception('cURL - не установлен');
    }     
  }
  
  /**
    * Запрашиваем данные пользователя
   *
  */  
  public function getUserInfo($oauth_token){

    if ($curl = curl_init()) {
      curl_setopt($curl, CURLOPT_URL, $this->login_url);
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
      curl_setopt($curl, CURLOPT_HTTPHEADER, [
        'Authorization:'.'oAuth '.$oauth_token
      ]);

      $out = curl_exec($curl);
      curl_close($curl);
      
      $result = json_decode($out);

      if(isset($result->default_email)){
        return $result;
      }
      
      return null;

    }else{
      throw new Exception('cURL - не установлен');
    }
  
  }    
  
  public function logs($type, $data){
    $file = __DIR__.'/debug_'.$type.'.txt';
    $current = var_export($data, true);
    file_put_contents($file, $current);   
  }
}