<?php
/**
 * @package   Yandex id
 * @author    Outcode https://outcode.ru/
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

class YandexidControllerMain extends JControllerLegacy
{
  
  public $redirect_main = 'index.php?option=com_yandexid';
  
  function __construct($config = array()){
    parent::__construct( $config );
    $this->registerTask('apply', 'save');
  }

  function display($cachable = false, $urlparams = false){ 
    $params = JComponentHelper::getParams('com_yandexid');
    $groups = $this->getUserGroups();
    $user_fields = $this->getFields();

    // Подключили шаблон страницы
    $view = $this->getView('yandexid', 'html');
    $view->setLayout('main');
    
    // Добавляем переменные в шаблон
    $view->assign('title', $params->get('title', ''));
    $view->assign('groups', $groups);
    $view->assign('group', $params->get('group', 1));
    $view->assign('type_selection', $params->get('type_selection', ''));
    $view->assign('suggest_button_view', $params->get('suggest_button_view', ''));
    $view->assign('suggest_parent_id', $params->get('suggest_parent_id', 'yandex-id-container'));
    $view->assign('suggest_button_border_radius', $params->get('suggest_button_border_radius', 0));
    $view->assign('suggest_button_theme', $params->get('suggest_button_theme', ''));
    $view->assign('suggest_button_size', $params->get('suggest_button_size', ''));
    
    $view->assign('scope_login_info', $params->get('scope_login_info', 0));
    $view->assign('scope_login_default_phone', $params->get('scope_login_default_phone', 0));
    $view->assign('scope_login_birthday', $params->get('scope_login_birthday', 0));
    
    $view->assign('user_fields', $user_fields);
    $view->assign('first_name', $params->get('first_name', 'no'));
    $view->assign('last_name', $params->get('last_name', 'no'));
    $view->assign('default_phone', $params->get('default_phone', 'no'));
    $view->assign('login_birthday', $params->get('login_birthday', 'no'));
    
    $view->assign('suggest_color_bg_base', $params->get('suggest_color_bg_base', ''));
    $view->assign('suggest_color_bg_hovered', $params->get('suggest_color_bg_hovered', ''));
    $view->assign('suggest_color_border_base', $params->get('suggest_color_border_base', ''));
    $view->assign('suggest_color_border_hovered', $params->get('suggest_color_border_hovered', ''));
    $view->assign('suggest_border_thickness', $params->get('suggest_border_thickness', 0));
    
    // Скрытые
    $view->assign('yandexid_oauth_token', $params->get('yandexid_oauth_token', ''));
    $view->assign('yandexid_expires_oauth_token', $params->get('yandexid_expires_oauth_token', ''));
    // Клиентское приложение
    $view->assign('yandexid_app_client_id', $params->get('yandexid_app_client_id', ''));
    $view->assign('yandexid_app_client_secret', $params->get('yandexid_app_client_secret', ''));
    
    $view->displayMain(); 
  }
  
  public function save(){
    if ($this->checkToken['save']){
      JSession::checkToken() or die('Invalid Token');
    }
    
    $params = JComponentHelper::getParams('com_yandexid');

    $params->set('title', $this->input->get('title', '', 'STRING'));
    $params->set('group', $this->input->get('group', 1, 'INT'));
    $params->set('type_selection', $this->input->get('type_selection', '', 'STRING'));
    $params->set('suggest_button_view', $this->input->get('suggest_button_view', '', 'STRING'));
    $params->set('suggest_parent_id', $this->input->get('suggest_parent_id', 'yandex-id-container', 'STRING'));
    $params->set('suggest_button_border_radius', $this->input->get('suggest_button_border_radius', '', 'INT'));
    $params->set('suggest_button_theme', $this->input->get('suggest_button_theme', '', 'STRING'));
    $params->set('suggest_button_size', $this->input->get('suggest_button_size', '', 'STRING'));

    $params->set('scope_login_info', $this->input->get('scope_login_info', 0, 'INT'));
    $params->set('scope_login_default_phone', $this->input->get('scope_login_default_phone', 0, 'INT'));
    $params->set('scope_login_birthday', $this->input->get('scope_login_birthday', 0, 'INT'));
    
    $params->set('first_name', $this->input->get('first_name', 'no', 'STRING'));
    $params->set('last_name', $this->input->get('last_name', 'no', 'STRING'));
    $params->set('default_phone', $this->input->get('default_phone', 'no', 'STRING'));
    $params->set('login_birthday', $this->input->get('login_birthday', 'no', 'STRING'));

    $params->set('suggest_color_bg_base', $this->input->get('suggest_color_bg_base', '', 'STRING'));
    $params->set('suggest_color_bg_hovered', $this->input->get('suggest_color_bg_hovered', '', 'STRING'));
    $params->set('suggest_color_border_base', $this->input->get('suggest_color_border_base', '', 'STRING'));
    $params->set('suggest_color_border_hovered', $this->input->get('suggest_color_border_hovered', '', 'STRING'));
    $params->set('suggest_border_thickness', $this->input->get('suggest_border_thickness', '', 'INT'));
    
    // Скрытые
    $params->set('yandexid_oauth_token', $this->input->get('yandexid_oauth_token', '', 'STRING'));
    $params->set('yandexid_expires_oauth_token', $this->input->get('yandexid_expires_oauth_token', '', 'STRING'));
    // Клиентское приложение
    $params->set('yandexid_app_client_id', $this->input->get('yandexid_app_client_id', '', 'STRING'));
    $params->set('yandexid_app_client_secret', $this->input->get('yandexid_app_client_secret', '', 'STRING'));

    $componentid = JComponentHelper::getComponent('com_yandexid')->id;
    $table = JTable::getInstance('extension');
    $table->load($componentid);
    $table->bind(array('params' => $params->toString()));
    $table->check();
    $table->store();

    $this->setRedirect($this->redirect_main);
  }
    
  public function getUserGroups(){
    if (!class_exists('UsersHelper')){
      require JPATH_ROOT . '/administrator/components/com_users/helpers/users.php';      
    }
    
    return UsersHelper::getGroups();  
  }
  
  public function getFields(){
    if (!class_exists('FieldsHelper')){
      require JPATH_ROOT . '/administrator/components/com_fields/helpers/fields.php';      
    }
    
    $output = ['no' => [
      'title' => JText::_('COM_YANDEXID_TXT_31'),
      'name' => 'no'
    ]];
    
    $fields = FieldsHelper::getFields('com_users.user'); 
    
    foreach($fields as $field){
      $output[$field->id] = [
        'title' => $field->title,
        'name' => $field->name
      ];
    }

    return $output;
  }
  
  
}