(function($) { 

  $(document).ready(function(){
  
    let form = $('.com-yandexid');

    btnSettings();
    btnSuggestSettings();    
    mapFieldPhone();
    mapFieldBirthday();
    mapFieldFirstLastName();
    showBtnExample();

    $('.oauth-app .button').click(function(){
    
      if($(this).hasClass('ajax-work') == true){
        return false;
      }
      
      $(this).addClass('ajax-work');    
    
      $.ajax({
        url         : '/index.php/component/com_yandexid/yandexid/create_oauth_app',
        type        : 'POST',
        data        : {},
        dataType    : 'json',       
        success     : function( respond, status, jqXHR ){
          
          $('.oauth-app .button').removeClass('ajax-work');
          
          let messageBox = $('.oauth-app .ya-message');
          
          messageBox.html(respond.message);
          messageBox.animate({opacity: '1'}, 200, 'linear', function(){
            setTimeout(function() {              
              $('.oauth-app .ya-message').animate({opacity: '0'}, 200);
            },3000);
          }); 

        },
        error: function( jqXHR, status, errorThrown ){
          console.log( 'ОШИБКА AJAX запроса: ' + status, jqXHR );
          $('.oauth-app .button').removeClass('ajax-work');
        }
      });
      });
    
    $('#edit-type_selection').change(function(e){
      btnSettings();
    });
    
    $('#edit-suggest_button_view').change(function(e){
      btnSuggestSettings();
      showBtnExample();
    });
    
    $('#edit-suggest_button_theme').change(function(e){
      showBtnExample();
    });    
    
    $('#scope_login_info').change(function(e){
      mapFieldFirstLastName();
    });
    
    $('#scope_login_default_phone').change(function(e){
      mapFieldPhone();
    });
    
    $('#scope_login_birthday').change(function(e){
      mapFieldBirthday();
    });
    
    function mapFieldFirstLastName(){
      let checkbox = form.find('#scope_login_info');
      
      if(checkbox.prop('checked')){
        form.find('.form-item-first_name').show();
        form.find('.form-item-last_name').show();
      }else{
        form.find('.form-item-first_name').hide();
        form.find('.form-item-last_name').hide();
      }
    }
    
    function mapFieldPhone(){
      let checkbox = form.find('#scope_login_default_phone');
      
      if(checkbox.prop('checked')){
        form.find('.form-item-default_phone').show();
      }else{
        form.find('.form-item-default_phone').hide();
      }
    }
    
    function mapFieldBirthday(){
      let checkbox = form.find('#scope_login_birthday');
      
      if(checkbox.prop('checked')){
        form.find('.form-item-login_birthday').show();
      }else{
        form.find('.form-item-login_birthday').hide();
      }
    }

    function btnSettings(){
      let yandexidType = form.find('#edit-type_selection').val();

      if(yandexidType == 'widget'){
        form.find('#edit-main2').hide();
      }else{
        form.find('#edit-main2').show();
      }    
    }
    
    function btnSuggestSettings(){
      let yandexidBtnView = form.find('#edit-suggest_button_view').val();

      if(yandexidBtnView == 'iconGrey' || yandexidBtnView == 'iconBorder'){
        form.find('div.icon').show();
      }else{
        form.find('div.icon').hide();
      }    
    }
    
    function showBtnExample(){
      let view = form.find('#edit-suggest_button_view').val();
      let theme = form.find('#edit-suggest_button_theme').val();
      
      form.find('.btn-example img').hide();
      
      if(view == 'main' && theme == 'light'){
        form.find('.btn-example .main-light').show();
      }else if(view == 'main' && theme == 'dark'){
        form.find('.btn-example .main-dark').show();
      }else if(view == 'additional' && theme == 'light'){
        form.find('.btn-example .additional-light').show();
      }else if(view == 'additional' && theme == 'dark'){
        form.find('.btn-example .additional-dark').show();
      }else if(view == 'icon'){
        form.find('.btn-example .icon').show();
      }else if(view == 'iconGrey'){
        form.find('.btn-example .icongrey').show();
      }else if(view == 'iconBorder'){
        form.find('.btn-example .iconborder').show();
      } 
    }

  });

})(jQuery);