<?php
/**
 * @package   Yandex id
 * @author    Outcode https://outcode.ru/
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

defined('_JEXEC') or die;
?>

	<script src="https://yastatic.net/s3/passport-sdk/autofill/v1/sdk-suggest-with-polyfills-latest.js"></script>

  <div id="yandex-id-container"></div>

  <script>

    let tokenPageOrigin = '<?=$tokenPageOrigin?>';
    
    let oauthQueryParams = {
          client_id: '<?=$client_id?>',
          response_type: 'token',
          redirect_uri: '<?=$redirect_uri?>' 
        };
        
    let suggestParams = {
          view: 'button',
          parentId: '<?=$parent_id?>',
          buttonView: '<?=$button_view?>',
          buttonTheme: '<?=$button_theme?>',
          buttonSize: '<?=$button_size?>',
          buttonBorderRadius: <?=$button_border_radius?>    
      };
 
    <?php if($color_bg_base != ''): ?>  
      suggestParams.customBgColor = '<?=$color_bg_base?>';
    <?php endif; ?>  
    
    <?php if($color_bg_hovered != ''): ?>  
      suggestParams.customBgHoveredColor = '<?=$color_bg_hovered?>';
    <?php endif; ?> 
      
    <?php if($color_border_base != ''): ?>  
      suggestParams.customBorderColor = '<?=$color_border_base?>';
    <?php endif; ?> 
    
    <?php if($color_border_hovered != ''): ?>  
      suggestParams.customBorderHoveredColor = '<?=$color_border_hovered?>';
    <?php endif; ?> 
    
    <?php if($border_thickness != ''): ?>  
      suggestParams.customBorderWidth = '<?=$border_thickness?>';
    <?php endif; ?> 
   
    window.addEventListener("load", function(event) {
    
      <?php if($type_selection == 'widget'): ?>
        initYandexIdV1();
      <?php else: ?>
        initYandexIdV2();
      <?php endif; ?>

    });
    

    // Виджет «Мгновенный вход»
    function initYandexIdV1(){

      window.YaAuthSuggest.init(oauthQueryParams, tokenPageOrigin)
      .then(function(result) {
        return result.handler();
      })
      .then(function(data) {
        authorizationUser(data.access_token);
        console.log('Сообщение с токеном: ', data);
      })
      .catch(function(error) {
        console.log('Что-то пошло не так: ', error);
      });  
    }
    
    // Кнопка авторизации
    function initYandexIdV2(){
      console.log(oauthQueryParams);
    
      window.YaAuthSuggest.init(oauthQueryParams, tokenPageOrigin, suggestParams)
      .then(function(result) {
        return result.handler();
      })
      .then(function(data) {
        authorizationUser(data.access_token);
        console.log('Сообщение с токеном: ', data);
      })
      .catch(function(error) {
        console.log('Что-то пошло не так: ', error);
      });  
    }
    
    // Авторизация пользователя
    function authorizationUser(access_token){
      
      let url = '/index.php/component/com_yandexid/yandexid/authorization_user';
      
      url = url + '?access_token=' + access_token;

      let options = {
          method: "GET",
          headers: {
            'Content-Type': 'application/json'
          }
      }    
      
      fetch(url, options)
      .then(response => response.json())
      .then( result => {

        if(result.error == false){
          window.location.href = '/';
        }else{
          alert(result.message);
          window.location.href = '/';
        }

      })
      .catch(error => console.log("error", error));
    }  

  </script>
